/*
 * snd_allegro.c
 *
 * allegro sound interface
 */

/* $Id: snd_allegro.c,v 1.2 1999/10/31 14:43:02 nyef Exp $ */


#include "darcdc.h"
#include "ui.h"
#include "snd.h"

uint32 *kos_buf;
int stop_stream;
unsigned char *audio_buffer;

void snd_output_4_waves(int samples, u8 *wave1, u8 *wave2, u8 *wave3, u8 *wave4) {
        //audio_buffer=wave1 + wave2 + wave3 + wave4;
        memcpy(audio_buffer,wave1,sizeof(wave1));
        memcpy(audio_buffer+(sizeof(wave1)),wave2,sizeof(wave2));
        memcpy(audio_buffer+(sizeof(wave2)),wave3,sizeof(wave3));
        memcpy(audio_buffer+(sizeof(wave3)),wave4,sizeof(wave4));
}

void* kos_audio_callback(int size) {
        if(stop_stream) return NULL;
        return audio_buffer;
}

void snd_init(void) {
        stop_stream=0;
        printf("snd_init();\r\n");
        audio_buffer = (char *)malloc(1024*1024);
        memset(audio_buffer, 0, 1024*1024);
        kos_stream_init(kos_audio_callback);
        stream_start(44100, 1);
}

int snd_open(int samples_per_sync, int sample_rate) {
        return 0;
}

void snd_close(void) {
        stop_stream=1;
        printf("snd_close();\r\n");
        stream_shutdown();
        free(audio_buffer);
}

/*
 * $Log: snd_allegro.c,v $
 * Revision 1.2  1999/10/31 14:43:02  nyef
 * fixed to compile without warnings
 * fixed to only stop the audio stream if we actually had one
 *
 * Revision 1.1  1999/10/31 02:37:46  nyef
 * Initial revision
 *
 */
