/*
 * video_allegro.c
 *
 * display screen management
 */

/* $Id: video_allegro.c,v 1.11 2000/05/31 01:26:16 nyef Exp $ */

#include "darcdc.h"
#include "video.h"
#include "tool.h"

int video_active = 0;
int deblevel = 0;

unsigned char *nes_image;
int buffer_x;
int buffer_y;

//typedef void ((*xlatfunc)(BITMAP *, char *));

unsigned char *vbpfunc8(int line);

unsigned char *vid_pre_xlat;
void init_xlate8(int colors, int *red, int *green, int *blue);

#define RGB565(r, g, b) ((r >> 3) << 11)| ((g >> 2) << 5)| ((b >> 3) << 0)

uint16 *texture;
uint32 tex;
void video_init() {
        int x,y;
        tex = ta->txr_allocate(256*256*2);
        texture = ta->txr_map(tex);
        for(x = 0; x < 256; x++)
                for(y = 0; y < 256; y++)
                        texture[256*y + x] = RGB565(0,0,0);
        nes_image=malloc(480*640*2);
        for(x = 0; x < 256; x++)
                for(y = 0; y < 256; y++)
                        nes_image[256*y + x] = RGB565(0,0,0);
}

void video_shutdown(void)
{
        free(nes_image);
        free(vid_pre_xlat);
        ta->txr_release_all();
        printf("shutting down video\r\n");
}

void video_enter_deb(void)
{
    if (video_active && (!deblevel)) {

    }
    deblevel++;
}

void video_leave_deb(void)
{
    deblevel--;
    if (video_active && (!deblevel)) {

    }
}

void video_setsize(int x, int y)
{
    /* FIXME: add real implimentation */
    buffer_x = x;
    buffer_y = y;
}

int xpal[256];
typedef struct RGB
{
   int r,g,b;
} RGB;

typedef struct {
	float   x, y, z;
	float   u, v;
} polyPlace_t;

polyPlace_t polys = { 128.0f, 0.0f, 1.0f, 0.0f, 0.0f };

void drawPoly(polyPlace_t *p) {
	/* Opaque Colored vertex */
	vertex_ot_t vert;

	vert.flags = TA_VERTEX_NORMAL;
	vert.x = p->x + 0.0f; vert.y = p->y + 480.0f; vert.z = p->z;
	vert.a = 1.0f; vert.r = 1.0f; vert.g = 1.0f; vert.b = 1.0f;
	vert.u = 0.0f; vert.v = 1.0f;
        ta->commit_vertex(&vert, sizeof(vert));
	
	vert.flags = TA_VERTEX_NORMAL;
	vert.x = p->x + 0.0f; vert.y = p->y + 0.0f;
	vert.v = 0.0f;
        ta->commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_NORMAL;
	vert.x = p->x + 432.0f; vert.y = p->y + 480.0f;
	vert.u = 1.0f; vert.v = 1.0f;
        ta->commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_EOL;
	vert.x = p->x + 432.0f; vert.y = p->y + 0.0f;
	vert.v = 0.0f;
        ta->commit_vertex(&vert, sizeof(vert));
}
void video_display_buffer() {
        int x,y,c;
        poly_hdr_t poly;

        for (y=0; y<buffer_y; y++) {
                char *p = &nes_image[y * buffer_x];
                        for (x=0; x<buffer_x; x++) {
                                c = (p[x]);
                                texture[y*256+x] = xpal[c];
			}
        }

        ta->poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565, 256, 256, tex, 0);
        ta->commit_poly_hdr(&poly);
	drawPoly(&polys);
        ta->commit_eol();
        ta->poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_NO_TEXTURE, 0, 0, 0, 0);
        ta->commit_poly_hdr(&poly);
        ta->commit_eol();
        ta->finish_frame();

}

unsigned char *video_get_vbp(int line) {
        return nes_image+(line*256);
}

void set_color(int index, RGB pal) {
        xpal[index] = RGB565(pal.r,pal.g,pal.b);
}

void video_setpal(int colors, int *red, int *green, int *blue)
{
    int i;
    RGB color;
    
    vid_pre_xlat = malloc(colors);

    for (i = 0; i < 64; i++) {
        //color.r = red[i] >> 2;
        //color.g = green[i] >> 2;
        //color.b = blue[i] >> 2;
        color.r = red[i];
        color.g = green[i];
        color.b = blue[i];
        set_color(i + 64, color);
	vid_pre_xlat[i] = i + 64;
    }
}


/*
 * $Log: video_allegro.c,v $
 * Revision 1.11  2000/05/31 01:26:16  nyef
 * fixed (hopefully) to work with the new video interface
 *
 * Revision 1.10  1999/02/09 02:28:30  nyef
 * added dummy implimentation of video_setsize()
 *
 * Revision 1.9  1999/02/09 02:10:43  nyef
 * moved video_events() out to ui_allegro.c
 *
 * Revision 1.8  1999/02/09 02:08:49  nyef
 * removed the (dead) vidxlate stuff and the #ifdef GRAPHICS stuff
 *
 * Revision 1.7  1999/01/08 02:35:16  nyef
 * commented out include of nespal.c, which was causing problems.
 *
 * Revision 1.6  1999/01/07 03:20:21  nyef
 * added in hacked up palette interface.
 *
 * Revision 1.5  1998/12/18 04:19:01  nyef
 * changed video driver from autodetect to vesa1.
 *
 * Revision 1.4  1998/10/02 03:29:54  nyef
 * fixed a few small problems that were preventing compilation.
 * nothing major, just stupid things.
 *
 * Revision 1.3  1998/09/02 01:45:01  nyef
 * updated to cover the new buffering scheme and ppu interface.
 *
 * Revision 1.2  1998/07/31 10:46:31  nyef
 * moved includes around a bit to squash EOF redefinition.
 *
 * Revision 1.1  1998/07/31 01:59:21  nyef
 * Initial revision
 *
 */
